function [firstder]=first_derivative(N,T,K,Dy,DW,Phi,phi,omega,sig2_u,inOmegastar)
 % vector of first derivatives of the trasformed log-likelihood in Hsiao et al 2002
% see transformed_ml.m
 
dim_phi = size(DW,3);
g = 1+T*(omega-1); 
firstder = zeros(dim_phi+2,1);
 
 for i=1:N
    Dyi = Dy(:,i);
    DWi = squeeze(DW(:,i,:));
    Dui =  Dyi - DWi*phi;
    firstder(1:dim_phi,1) = firstder(1:dim_phi,1) + (1/sig2_u)*DWi'*inOmegastar*Dui;
    firstder(dim_phi+1,1)   = firstder(dim_phi+1,1)   + (1/(2*sig2_u*g^2))* Dui'*Phi*Dui;
    firstder(dim_phi+2,1)   = firstder(dim_phi+2,1)   + (1/(2*sig2_u^2))* Dui'*inOmegastar*Dui;
end
 
    firstder(dim_phi+1,1) = firstder(dim_phi+1,1) - (N*T)/(2*g);
    firstder(dim_phi+2,1) = firstder(dim_phi+2,1) - (N*T)/(2*sig2_u);
