function [secder]=second_derivative(N,T,K,Dy,DW,Phi,phi,omega,sig2_u,inOmegastar)
 
% vector of second derivatives of the trasformed log-likelihood in Hsiao et
% al 2002. see transformed_ml.m

dim_phi = size(DW,3);
g = 1+T*(omega-1);
secder = zeros(dim_phi+2,dim_phi+2);
 
for i=1:N
    Dyi = Dy(:,i);
    DWi = squeeze(DW(:,i,:));
    Dui =  Dyi - DWi*phi;
    secder(1:dim_phi,1:dim_phi)  = secder(1:dim_phi,1:dim_phi) + (1/sig2_u)*DWi'*inOmegastar*DWi;
    secder(dim_phi+1,dim_phi+1)  = secder(dim_phi+1,dim_phi+1) + (T/(sig2_u*g^3))*Dui'*Phi*Dui;
    secder(dim_phi+2,dim_phi+2)  = secder(dim_phi+2,dim_phi+2) + (1/sig2_u^3)*Dui'*inOmegastar*Dui;
    secder(1:dim_phi,dim_phi+1)  = secder(1:dim_phi,dim_phi+1) + (1/(sig2_u*g^2))*DWi'*Phi*Dui;
    secder(1:dim_phi,dim_phi+2)  = secder(1:dim_phi,dim_phi+2) + (1/(sig2_u*g^2))*DWi'*inOmegastar*Dui;
    secder(dim_phi+1,dim_phi+2)  = secder(dim_phi+1,dim_phi+2) + (1/(2*sig2_u^2*g^2))*Dui'*Phi*Dui;
 end
 
  secder=-secder;
  
  secder(dim_phi+1,dim_phi+1) = secder(dim_phi+1,dim_phi+1) + (N*T^2)/(2*g^2);
  secder(dim_phi+2,dim_phi+2) = secder(dim_phi+2,dim_phi+2) + (N*T)/(2*sig2_u^2);
  secder(dim_phi+1,1:dim_phi) = secder(1:dim_phi+0,dim_phi+1)';
  secder(dim_phi+2,1:dim_phi) = secder(1:dim_phi+0,dim_phi+2)';
  secder(dim_phi+2,dim_phi+1) = secder(dim_phi+1,dim_phi+2);
